#!/bin/zsh
# Copyright 2011 Paul Haensch
# This file is part of Busy
#
# Busy is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Busy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with Busy.  If not, see <http://www.gnu.org/licenses/>.

#info="$(egrep -o '(^|&)i=[0-9]{10}_[0-9]{3}(&|$)' <<<"${QUERY_STRING}" |tr -d '&i=')"
[ "$HTTPS" = "on" ] && PROTO=https || proto=http

. ../auth/permissions.sh
$ACL_CREATETASK || echo "Location: ${proto}://${HTTP_HOST}/?p=Error&i=noaccess\n\n"
$ACL_CREATETASK || exit 0

info="$(sed -r 's:(^|.*&)i=(.*)|.*:\2:;s:&.*::' <<<"${QUERY_STRING}")"

[ -z "$info" ] && info="$(date +%s)_$(apg -M N -a 1 -n 1 -m 3 -x 3)"
descfile="../Tasks/$info.meta"
commfile="../Tasks/$info.comment.$(date +%s)_$(apg -M N -a 1 -n 1 -m 3 -x 3)"

[ -f "../Tasks/$info.lock" ] && rm "../Wiki/$info.lock"
anchor=$(ls ../Tasks |grep -A2 $info |grep '.meta$' |tail -n1 |cut -d. -f1)

if [ -n "${CONTENT_LENGTH}" -a "${CONTENT_LENGTH}" -gt 0 ]; then
(head -c "${CONTENT_LENGTH}"; echo)|sed 's/&/\n/g' |while read line; do
  if (egrep -xq 'headline=.+' <<<"${line}"); then
    headline="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    headline="$(echo -e "${headline}" |sed 's/\t/ /g;s/\r//g;s/\\/\\\\/g' |head -n1)"
  elif (egrep -xq 'status=.+' <<<"${line}"); then
    taskstatus="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    taskstatus="$(echo -e "${taskstatus}" |sed 's/\t/ /g;s/\r//g;s/\\/\\\\/g' |head -n1)"
  elif (egrep -xq 'section=.+' <<<"${line}"); then
    section="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    section="$(echo -e "${section}" |sed 's/\t/ /g;s/\r//g;s/\\/\\\\/g' |head -n1)"
  elif (egrep -xq 'description=.+' <<<"${line}"); then
    description="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    description="$(echo -e "${description}" |sed 's/\r//g;s/\\/\\\\/g')"
  elif (egrep -xq 'comm=.+' <<<"${line}"); then
    comment="$(cut -d= -f2- <<<"${line}" |sed 's/+/ /g;s/%/\\x/g')"
    comment="$(echo -e "${comment}" |sed 's/\r//g;s/\\/\\\\/g')"
  elif (egrep -xq 'cancel=.+' <<<"${line}"); then
    cancel="true"
  elif (egrep -xq 'submit=Robots click here' <<<"${line}"); then
    cancel="true"
  fi
done
fi

if [ -z "$cancel" -a -n "$comment" ]; then
  touch "../Tasks/$info"
  echo -e "author=${REMOTE_USER}" > "$commfile"
  echo -e "${comment}" >> "$commfile"
  echo -n "Location: ${proto}://${HTTP_HOST}/?p=Tasks&i=$info\n\n"
elif [ -z "$cancel" -a -n "$description" ]; then
  touch "../Tasks/$info"
  echo -e "headline=${headline}" > "$descfile"
  echo -e "status=${taskstatus}" >> "$descfile"
  echo -e "section=${section}" >> "$descfile"
  echo -e "${description}" >> "../Tasks/$info"
  echo -n "Location: ${proto}://${HTTP_HOST}/?p=Tasks#$anchor\n\n"
elif [ -n "$cancel" ]; then
  echo -n "Location: ${proto}://${HTTP_HOST}/?p=Tasks#$anchor\n\n"
fi
